/* splittet CDLX-Files in ILBM-Einzelbilder */

IF ~SHOW('LIBRARIES','rexxsupport.library') THEN DO
   IF ~ADDLIB('rexxsupport.library',10,-30,0) THEN DO
      SAY 'Kann die <rexxsupport.library> nicht ffnen!'
      EXIT(10)
   END
END
Parse Arg OPTS
Parse Value OPTS with CDXL ' ' ILBMDIR ' ' ANIM
Parse Value CDXL with PriName '.' Ext
Name="" ; D=Length(PriName)
Do Forever
Chr=Substr(PriName,D,1)
If Chr="/" | Chr=":" Then Leave
Name=Chr||Name ; D=D-1
End
Call Savety()
Frame=0
Do Forever
Call Blockheader()
If RPos>=SUBWORD(STATEF(CDXL),2,1) Then Do
If ANIM=NO Then Say '0a'x||"End"
Leave
End
Call Headparsing()
Call Convertpalette()
Call Convertbody()
Call Buildilbm()
End
If ANIM=YES Then Call Buildanim()
Exit(0)

Buildanim:
Say '0a'x||"fge Anim zusammen"
Quelle=ILBMDir||Name||"."||"00000" ; Ziel=ILBMDir||Name||"."||"anim Anim5 Reltime 3"
Address Command Buildanim Quelle Ziel
Say "End"
return

Buildilbm:
NR=Frame
Do Until(Length(NR)>4)
NR="0"||NR
End
Ilbmpath=ILBMDir||Name||"."||NR
Frame=Frame+1
Call Open(Ilbmpath,Ilbmpath,W)
Wr=Writech(STDOUT, '0d1b5b4b'x ||"speichere "||Ilbmpath)
HEAD=FORM||X2C(D2X(0,8))
HEAD=HEAD||ILBMBMHD||X2C(D2X(20,8))||X2C(D2X(Width,4))||X2C(D2X(Height,4))||X2C(D2X(0,8))
HEAD=HEAD||X2C(D2X(Depth,2))||X2C(D2X(0,6))||X2C(D2X(0,8))||X2C(D2X(Width,4))||X2C(D2X(Height,4))
HEAD=HEAD||CAMG||X2C(D2X(4,8))||X2C(D2X(135168+HAM,8))||CMAP||X2C(D2X(Length(NewPalette),8))
Wr=Writech(Ilbmpath,Head)
Wr=Writech(Ilbmpath,NewPalette)
HEAD=BODY||X2C(D2X(Length(Newbody),8))
Wr=Writech(Ilbmpath,Head)
Wr=Writech(Ilbmpath,NewBody)
Cl=Close(IlbmPath)
Laenge=SUBWORD(STATEF(Ilbmpath),2,1)-8
Call Open(Ilbmpath,Ilbmpath,A)
RPOS=Seek(Ilbmpath,4,Begin)
Wr=Writech(Ilbmpath,X2C(D2X(Laenge,8)))
Cl=Close(IlbmPath)
return

Convertbody:
NewBody=""
Do D=0 To Height-1
   Do DL=0 to Depth-1
   NewBody=NewBody||Substr(Planarbody,(D*(Width%8))+(DL*PlaneSize)+1,Width%8)
   End
End
return

Convertpalette:
Newpalette=""
Do D=1 to Length(Palette) By 2
color=C2D(Substr(Palette,D,2))
R=Color%256*17
G=Color//256%16*17
B=Color//16*17
Newpalette=Newpalette||X2C(D2X(R,2))||X2C(D2X(G,2))||X2C(D2X(B,2))
End
return

Headparsing:
Blocklength=C2D(Readch(CDXL,2))
RPos=Seek(CDXL,8,current)
Width=C2D(Readch(CDXL,2))
Height=C2D(Readch(CDXL,2))
RPos=Seek(CDXL,1,current)
Depth=C2D(Readch(CDXL,1))
RPos=Seek(CDXL,12,current)
If Ham=0 Then Palette=Readch(CDXL,2 ** Depth*2)
Else Palette=Readch(CDXL,32)
Planarbody=Readch(CDXL,(Width%8)*Depth*Height)
PlaneSize=(Width%8)*Height
Rpos=Seek(CDXL,LastStartPos+Blocklength,Begin)
return


Blockheader:
LastStartPos=Seek(CDXL,0,current)
RPos=Seek(CDXL,1,current)
Kennung=C2D(Readch(CDXL,1))
RPos=Seek(CDXL,2,current)
If Kennung=1 Then HAM=2048
Else Ham=0
return

Savety:
IF Exists(CDXL)=0 Then OptsError=1
If Upper(Anim)="ANIM" Then ANIM=YES
Else ANIM=NO
If ILBMDIR="" | CDXL="" Then OptsError=1
If OptsError~="OPTSERROR" Then Do
Say "ilbm2cdxl cdxl-file outdir"
Exit(0)
End
If (Right(ILBMDIR,1) ~= ":" & Right(ILBMDIR,1) ~= "/") Then ILBMDIR=ILBMDIR||"/"
Call Open(CDXL,CDXL,R)
return
